unit uFrmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, uCountThread, uFooList;

type

  TCountThreadList = Class(TFooList<TCountThread>) // һ߳ List
  protected
    procedure FreeItem(Item: TCountThread); override; // ָ Item ͷŷʽ
  end;

  TNumList = Class(TFooList<Integer>); // һ Integer List

  TFrmMain = class(TForm)
    memMsg: TMemo;
    edtNum: TEdit;
    btnWork: TButton;
    lblInfo: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnWorkClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }

    FNumList: TNumList;
    FCountThreadList: TCountThreadList;

    FBuff: TStringList;
    FBuffIndex: Integer;
    FBuffMaxIndex: Integer;
    FWorkedCount: Integer;

    procedure DispMsg(AMsg: string);
    procedure OnThreadMsg(AMsg: string);

    function OnGetNum(Sender: TCountThread): Boolean;
    procedure OnCounted(Sender: TCountThread);

    procedure LockCount;
    procedure UnlockCount;

  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}
{ TFrmMain }

{ TCountThreadList }
procedure TCountThreadList.FreeItem(Item: TCountThread);
begin
  inherited;
  Item.Free;
end;

procedure TFrmMain.btnWorkClick(Sender: TObject);
var
  s: string;
  thd: TCountThread;
begin

  btnWork.Enabled := false;
  FWorkedCount := 0;
  FBuffIndex := 0;
  FBuffMaxIndex := FNumList.Count - 1;

  s := '' + IntToStr(FBuffMaxIndex + 1) + ',:' + IntToStr(FWorkedCount);
  lblInfo.Caption := s;

  for thd in FCountThreadList do
  begin
    thd.StartThread;
  end;

end;

procedure TFrmMain.DispMsg(AMsg: string);
begin
  memMsg.Lines.Add(AMsg);
end;

procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  // ֹڼ˳
  LockCount; // ˼ΪʲôҪ LockCount;
  CanClose := btnWork.Enabled;
  if not btnWork.Enabled then
    DispMsg('ڼ㣬׼˳!');
  UnlockCount;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
var
  thd: TCountThread;
  i: Integer;
begin

  FCountThreadList := TCountThreadList.Create;
  // Կ List ָ֮߳
  // ߳һ List У List Ϊ̳߳ء
  for i := 1 to 3 do
  begin
    thd := TCountThread.Create(false);
    FCountThreadList.Add(thd);
    thd.OnStatusMsg := self.OnThreadMsg;
    thd.OnGetNum := self.OnGetNum;
    thd.OnCounted := self.OnCounted;
    thd.ThreadName := '߳' + IntToStr(i);
  end;

  FNumList := TNumList.Create;
  // һ
  FNumList.Add(100);
  FNumList.Add(136);
  FNumList.Add(306);
  FNumList.Add(156);
  FNumList.Add(152);
  FNumList.Add(106);
  FNumList.Add(306);
  FNumList.Add(156);
  FNumList.Add(655);
  FNumList.Add(53);
  FNumList.Add(99);
  FNumList.Add(157);

end;

procedure TFrmMain.FormDestroy(Sender: TObject);
begin
  FNumList.Free;
  FCountThreadList.Free;
end;

procedure TFrmMain.LockCount;
begin
  System.TMonitor.Enter(btnWork);
end;

procedure TFrmMain.UnlockCount;
begin
  System.TMonitor.Exit(btnWork);
end;

procedure TFrmMain.OnCounted(Sender: TCountThread);
var
  s: string;
begin

  LockCount;
  // ͬĶòͬ
  // ÿĹҪһҪСЧʡ

  s := Sender.ThreadName + ':' + IntToStr(Sender.Num) + 'ۼӺΪ:';
  s := s + IntToStr(Sender.Total);
  OnThreadMsg(s);

  inc(FWorkedCount);

  s := '' + IntToStr(FBuffMaxIndex + 1) + ',:' + IntToStr(FWorkedCount);

  TThread.Synchronize(nil,
    procedure
    begin
      lblInfo.Caption := s;
    end);

  if FWorkedCount >= FBuffMaxIndex + 1 then
  begin
    TThread.Synchronize(nil,
      procedure
      begin
        DispMsg('Ѽ');
        btnWork.Enabled := true; // ָť״̬
      end);
  end;

  UnlockCount;

end;

function TFrmMain.OnGetNum(Sender: TCountThread): Boolean;
begin
  // ̷߳ FNumList Ŷӡ
  FNumList.Lock;
  try
    if FBuffIndex > FBuffMaxIndex then
    begin
      result := false;
    end
    else
    begin
      Sender.Num := FNumList[FBuffIndex];
      result := true;
      inc(FBuffIndex);
    end;
  finally
    FNumList.Unlock;
  end;
end;

procedure TFrmMain.OnThreadMsg(AMsg: string);
begin
  TThread.Synchronize(nil,
    procedure
    begin
      DispMsg(AMsg);
    end);
end;

end.
